--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/audio/cnc1900_audio.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/audio/cnc1900_audio.h	2015-06-19 15:58:42.412211000 +0800
@@ -0,0 +1,101 @@
+#ifndef __CNC1900_AUDIO_H__
+#define __CNC1900_AUDIO_H__
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#define AUDIO_MAJOR 400
+
+#ifdef CONFIG_SW_SUPPORT
+#undef CONFIG_SW_SUPPORT
+#endif
+
+#ifdef CONFIG_SW_SUPPORT
+#define AUDIO_INS_REGION	AUDIO_STUFF_REGION
+#define AUDIO_INS_SIZE (0x0)
+#define AUDIO_DATA_REGION	(AUDIO_INS_REGION + AUDIO_INS_SIZE)
+#define AUDIO_DATA_SIZE	(0x0)
+#define AUDIO_HOST_FW_IF_REGION	(AUDIO_DATA_REGION + AUDIO_DATA_SIZE)
+#define AUDIO_HOST_FW_IF_SIZE	(AUDIO_STUFF_SIZE - AUDIO_INS_SIZE - AUDIO_DATA_SIZE) /* AUDIO_HOST_FW_IF_SIZE + AUDIO pointer*/
+
+#define AUDIO_INS_OFFSET	(AUDIO_INS_REGION - AUDIO_STUFF_REGION)
+#define AUDIO_DATA_OFFSET	(AUDIO_DATA_REGION - AUDIO_STUFF_REGION)
+#define AUDIO_HOST_FW_IF_OFFSET	(AUDIO_HOST_FW_IF_REGION - AUDIO_STUFF_REGION)
+#else
+#define AUDIO_INS_REGION	AUDIO_STUFF_REGION
+#define AUDIO_INS_SIZE (0xf0000)
+#define AUDIO_DATA_REGION	(AUDIO_INS_REGION + AUDIO_INS_SIZE)
+#define AUDIO_DATA_SIZE	(0x180000)
+#define AUDIO_HOST_FW_IF_REGION	(AUDIO_DATA_REGION + AUDIO_DATA_SIZE)
+#define AUDIO_HOST_FW_IF_SIZE	(AUDIO_STUFF_SIZE - AUDIO_INS_SIZE - AUDIO_DATA_SIZE) /* AUDIO_HOST_FW_IF_SIZE + AUDIO pointer*/
+
+#define AUDIO_INS_OFFSET	(AUDIO_INS_REGION - AUDIO_STUFF_REGION)
+#define AUDIO_DATA_OFFSET	(AUDIO_DATA_REGION - AUDIO_STUFF_REGION)
+#define AUDIO_HOST_FW_IF_OFFSET	(AUDIO_HOST_FW_IF_REGION - AUDIO_STUFF_REGION)
+#endif
+#define CSAUD_IOC_GET_AUDIO_REG_ADDR	    _IOR('a', 0x01, int)
+#define CSAUD_IOC_GET_AUDIO_REG_SIZE		_IOR('a', 0x02, int)
+
+#define CSAUD_IOC_GET_AUDIO_HOST_IF_ADDR	_IOR('a', 0x03, int)
+#define CSAUD_IOC_GET_AUDIO_HOST_IF_SIZE	_IOR('a', 0x04, int)
+
+#define CSAUD_IOC_GET_AUDIO_NUM		        _IOR('a', 0x05, int)
+#define CSAUD_IOC_GET_AUDIO_ENC_NUM         _IOR('a', 0x06, int)
+#define	CSAUD_IOC_GET_AUDIO_CAB_ADDR        _IOR('a', 0x07, int)
+#define	CSAUD_IOC_GET_AUDIO_CAB_SIZE        _IOR('a', 0x08, int)
+#define	CSAUD_IOC_GET_AUDIO_PTS_ADDR        _IOR('a', 0x09, int)
+#define	CSAUD_IOC_GET_AUDIO_PTS_SIZE        _IOR('a', 0x0a, int)
+#define	CSAUD_IOC_GET_AUDIO_AAB_ADDR        _IOR('a', 0x0b, int)
+#define	CSAUD_IOC_GET_AUDIO_AAB_SIZE        _IOR('a', 0x0c, int)
+#define	CSAUD_IOC_GET_AUDIO_AAB_PTS_ADDR    _IOR('a', 0x0d, int)
+#define	CSAUD_IOC_GET_AUDIO_AAB_PTS_SIZE    _IOR('a', 0x0e, int)
+#define	CSAUD_IOC_GET_AUDIO_ENC_CAB_ADDR    _IOR('a', 0x0f, int)
+#define	CSAUD_IOC_GET_AUDIO_ENC_CAB_SIZE    _IOR('a', 0x10, int)
+#define	CSAUD_IOC_GET_AUDIO_ENC_PTS_ADDR    _IOR('a', 0x11, int)
+#define	CSAUD_IOC_GET_AUDIO_ENC_PTS_SIZE    _IOR('a', 0x12, int)
+
+
+
+#define CSAUD_IOC_GET_AUDIO_MIXER_ADDR	    _IOR('a', 0x13, int)
+#define CSAUD_IOC_GET_AUDIO_MIXER_IF_SIZE	_IOR('a', 0x14, int)
+#define CSAUD_IOC_GET_AUDIO_INS_ADDR		_IOR('a', 0x15, int)
+
+#define CSAUD_IOC_GET_XPORT_AUDIO	        _IOR('a', 0x16, int)
+#define CSAUD_IOC_GET_IRQ_TYPE		        _IOR('a', 0x17, int)
+
+#define CSAUD_IOC_GET_AUDIO_PROCESS_NUMBER  _IOR('a', 0x18, int)
+
+#define CSAUD_IOC_GET_SAMPLE_RATE		    _IOR('a', 0x19, int)
+#define CSAUD_IOC_SET_SAMPLE_RATE	        _IOW('a', 0x1a, int)
+
+#define CSAUD_IOC_ENA_AUDIO_DAC             _IOW('a', 0x1b, int)
+#define CSAUD_IOC_DIS_AUDIO_DAC             _IOW('a', 0x1c, int)
+
+#define CSAUD_IOC_RELOAD_FIRMWARE		    _IOW('a', 0x1d, int)
+
+typedef enum{
+	AUDIO_TYPE_MPA = 0,
+	AUDIO_TYPE_AC3 = 1,
+	AUDIO_TYPE_DTS = 2,
+	AUDIO_TYPE_LPCM = 3,
+	AUDIO_TYPE_AAC_ADTS = 4,
+	AUDIO_TYPE_AAC_LATM = 5,
+	AUDIO_TYPE_AIB = 6,
+	AUDIO_TYPE_UNKNOWN = 7,  // 5 bit
+}AUDIO_TYPE_e;
+
+unsigned int s_pop_mode[3] = {0x53,0xb3,0xf3};
+unsigned int s_pop_para[3][32] =
+	{	 // 1                                        9                                      17                                      25                                 32
+		  {0x01,0x2c,0x53,0x30,0x00,0x34,0x00,0x38,0x7f,0x3c,0x49,0x3c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
+		  {0x00,0x10,0x00,0x18,0x00,0x20,0x00,0x28,0x7f,0x2c,0x7f,0x2c,0x3f,0x2c,0x71,0x30,0x00,0x34,0x00,0x38,0x7f,0x3c,0x1f,0x3c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
+		  {0x00,0x00,0x01,0x08,0x00,0x0c,0x00,0x10,0x01,0x18,0x02,0x20,0x7f,0x28,0x7f,0x28,0x40,0x28,0x7f,0x2c,0x7f,0x2c,0x7f,0x2c,0x7f,0x30,0x7f,0x34,0x7f,0x3c,0x65,0x3c}
+	};
+
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/audio/Kconfig linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/audio/Kconfig
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/audio/Kconfig	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/audio/Kconfig	2014-08-19 17:41:23.254284000 +0800
@@ -0,0 +1,89 @@
+# drivers/celestial/audio/Kconfig
+
+menu "Celestial Audio Drivers"
+
+config CELESTIAL_AUDIO
+	bool "CNC1900 Audio"
+	depends on ARCH_CELESTIAL
+	default y
+	help 
+	    Include support drvier for Audio of celestial platform
+
+config AUDIO_DECODER
+	bool "Audio Decoder"
+	depends on CELESTIAL_AUDIO
+	default y
+	help 
+	    Enable Audio Decoder.Some projects no need to decoder audio date. It can be disabled for saving memory
+	    
+config AUDIO_ENCODER
+	bool "Audio Encoder"
+	depends on CELESTIAL_AUDIO
+	default y
+	help 
+	    Enable Audio Encoder.Some projects no need to encoder audio date. It can be disabled for saving memory
+
+config AUDIO_AAB
+	bool "Audio AAB"
+	depends on CELESTIAL_AUDIO
+	default y
+	help
+	    PCM audio buffer size for Dolby.Size 0x500000. 
+
+config AUDIO_NUM
+	int "Audio Decoder Number"
+	depends on AUDIO_DECODER
+	range 1 8
+	default 1
+	help
+	    Number of audio supported by audio decoder. Range from 1 to 8.
+
+config AUDIO_CAB_SIZE
+	hex "Audio Decoder CAB Size"
+	depends on AUDIO_DECODER
+	range 0x0 0x400000
+	default 0x200000
+	help
+	    Compressed audio buffer size for one audio. Range from 0x18000 to 0x400000.
+
+config AUDIO_ENC_NUM
+	int "Audio Encoder Number"
+	depends on AUDIO_ENCODER
+	range 1 8
+	default 1
+	help
+	    Number of audio supported by audio decoder. Range from 1 to 8.
+
+config AUDIO_ENC_CAB_SIZE
+	hex "Audio Encoder CAB Size"
+	depends on AUDIO_ENCODER
+	range 0x18000 0x400000
+	default 0x200000
+	help
+	    Compressed audio buffer size for one audio. Range from 0x18000 to 0x400000.
+
+
+config CELESTIAL_AUDIO_DEBUG
+	bool "Audio Debugging"
+	depends on CELESTIAL_AUDIO
+	help
+	    This turns on low-level debugging for the celestial audio driver.
+	    Normally, you should say 'N'.
+
+config AUDIO_DEBUG_VERBOSE
+	int "Audio Debugging verbosity (0 = quiet, 3 = noisy)"
+	depends on CELESTIAL_AUDIO_DEBUG
+	default "0"
+	help
+	    Determines the verbosity level of the audio debugging messages.
+
+config AUDIO_FW_DUMP_DEBUG
+        bool "Audio fw dump Debugging"
+        depends on CELESTIAL_AUDIO
+        default n
+        help
+            This turns on fw dump data debugging for the celestial audio driver.
+            It will occupy 5MB memory.
+            Normally, you should say 'N'.
+
+endmenu
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/audio/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/audio/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/audio/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/audio/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,9 @@
+#
+# Makefile for the linux kernel.
+# 
+#
+
+obj-$(CONFIG_MACH_CELESTIALSEMI_CSM1201) += 
+obj-$(CONFIG_MACH_CELESTIALSEMI_CSM1800H) += csm1800_audio.o
+obj-$(CONFIG_MACH_CELESTIAL_CNC1900) += cnc1900_audio.o
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/df/cnc1900_df.c linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/df/cnc1900_df.c
